Attribute VB_Name = "MiscFunctions"
Option Explicit

Public Function Get_WBufferFormat(Adapter As Long, DevType As CONST_D3DDEVTYPE, BackBufferFormat As CONST_D3DFORMAT) As CONST_D3DFORMAT
Get_WBufferFormat = D3DFMT_D16
If Direct3D.CheckDepthStencilMatch(Adapter, DevType, BackBufferFormat, BackBufferFormat, Get_WBufferFormat) = D3D_OK Then
    Exit Function
Else
    Get_WBufferFormat = D3DFMT_D32
    If Direct3D.CheckDepthStencilMatch(Adapter, DevType, BackBufferFormat, BackBufferFormat, Get_WBufferFormat) = D3D_OK Then
        Exit Function
    Else
        Get_WBufferFormat = 0
    End If
End If
End Function

Public Function GetConpatibeFormat(Adapter As Long, DevType As CONST_D3DDEVTYPE, BPP As Long) As CONST_D3DFORMAT
Dim Caps        As D3DDISPLAYMODE
Dim i           As Long

For i = 0 To Direct3D.GetAdapterModeCount(Adapter)
    Direct3D.EnumAdapterModes Adapter, DevType, Caps
    Select Case Caps.Format
        Case D3DFMT_X1R5G5B5, D3DFMT_R5G6B5, D3DFMT_A4R4G4B4, D3DFMT_X4R4G4B4, D3DFMT_A1R5G5B5 '16Bit
            If BPP = 16 Then
                If Direct3D.CheckDeviceFormat(Adapter, DevType, Caps.Format, D3DUSAGE_RENDERTARGET, D3DRTYPE_SURFACE, Caps.Format) = D3D_OK Then
                    GetConpatibeFormat = Caps.Format
                    Exit Function
                End If
            End If
        Case D3DFMT_A8R8G8B8, D3DFMT_X8R8G8B8 '32Bit
            If BPP = 32 Then
                If Direct3D.CheckDeviceFormat(Adapter, DevType, Caps.Format, D3DUSAGE_RENDERTARGET, D3DRTYPE_SURFACE, Caps.Format) = D3D_OK Then
                    GetConpatibeFormat = Caps.Format
                    Exit Function
                End If
            End If
    End Select
Next i
End Function
Public Function vec3(ByVal x As Single, ByVal y As Single, ByVal z As Single) As D3DVECTOR
With vec3
    .x = x
    .y = y
    .z = z
End With
End Function
Function FtoDW(f As Single) As Long
    Dim buf As D3DXBuffer
    Dim l As Long
    Set buf = D3Dx.CreateBuffer(4)
    D3Dx.BufferSetData buf, 0, 4, 1, f
    D3Dx.BufferGetData buf, 0, 4, 1, l
    FtoDW = l
End Function
