VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLighteningBolt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public iNext                As clsLighteningBolt
Public Parent               As clsLighteningMain

Private Lines()             As LineVertex
Private NumberLines         As Long

'Called only Once to get the bolt started sets the starting x,y,z and the color for the bolt'
Public Sub Init_Bolt(ByVal x As Single, ByVal y As Single, ByVal z As Single, ByVal iColor As Long)
ReDim Lines(1)
NumberLines = 1
With Lines(0)
    .x = x
    .y = y
    .z = z
    .Color = iColor
End With
With Lines(1)
    .x = x
    .y = y - 0.06
    .z = z
    .Color = iColor
End With
End Sub

'This Function Draws the Bolt if it returns False then the bolt is done and should be removed from
'the Bolt List
Public Function Draw_Bolt() As Boolean
NumberLines = NumberLines + 1
ReDim Preserve Lines(NumberLines)
With Lines(NumberLines)
    .x = Lines(NumberLines - 1).x + (1 - Rnd * 2) * 0.3
    .y = Lines(NumberLines - 1).y - (Rnd + 0.55)
    .z = Lines(NumberLines - 1).z + (1 - Rnd * 2) * 0.3
    .Color = Lines(0).Color
End With

Device.DrawPrimitiveUP D3DPT_LINESTRIP, NumberLines, Lines(0), Length_LineVertex

Draw_Bolt = True
If Lines(NumberLines).y <= Parent.Get_YFromXZ(Lines(1).x, Lines(1).z) Then
    If Rnd > 0.95 Then
        Draw_Bolt = False
    End If
End If
End Function

Private Sub Class_Terminate()
Set Parent = Nothing
Set iNext = Nothing

End Sub
